using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using BuechermarktClient.Models;
using System.Threading;
using MongoDB.Driver;
using System.Collections.Generic;

namespace BuechermarktClient
{
   /// <summary>
   /// Interaktionslogik für Students.xaml
   /// </summary>
   public partial class Students : Window
   {
      public Thread RefreshThread = null;
      private bool ThreadRunning = true;


      public bool Chooser = false;

      private string _SearchField;
      public string SearchField
      {
         get
         {
            return _SearchField;
         }
         set
         {
            if (value != _SearchField)
            {
               _SearchField = value;
            }
         }
      }

      public Student SelectedItem { get; private set; }

      public Students() : this(false){ }

      public Students(bool select)
      {
         DataContext = this;
         Chooser = select;
         InitializeComponent();
         InitializeComponent();
         RefreshThread = new Thread(RefreshThreadS);
         RefreshThread.Start();
         RefreshThread.IsBackground = true;
         Closing += Students_Closing;
      }


      private void Students_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
         ThreadRunning = false;
      }

      public void RefreshThreadS()
      {
         while (ThreadRunning)
         {
            LoadList();
            Thread.Sleep(1000);
         }
      }

      public void LoadList()
      {
         List<Models.Student> list = null;
         var not = true;
         while (not)
         {
            try
            {
               list = MainWindow.StudentCollection.FindSync((b) => true).ToList();
               not = false;
            }
            catch (MongoExecutionTimeoutException)
            {
               Thread.Sleep(200);
            }
         }

         var show = new List<Student>();
         if (SearchField != null && SearchField != String.Empty)
         {
            if(SearchField == "%d%")
            {
               foreach (var e in list)
               {
                  foreach (var e2 in list)
                  {
                     if (e.ID == e2.ID) continue;
                     if (e.LabelId == e2.LabelId) show.Add(e);
                  }
               }
            } else {
               foreach (var e in list)
               {
                  //
                  if (e.Forname.ToLower().Contains(SearchField.ToLower()) || e.Lastname.ToLower().Contains(SearchField.ToLower()) || e.EMail.ToLower().Contains(SearchField.ToLower()) || e.Form.ToLower().Contains(SearchField.ToLower()) || e.LabelId.ToLower().Contains(SearchField.ToLower()))
                  {
                     show.Add(e);
                  }
               }
            }
         }
         else
         {
            show = list;
         }
         Dispatcher.BeginInvoke(new Action(delegate () {
            ViewList.ItemsSource = show;
         }));
      }

      private void AddNew_Click(object sender, RoutedEventArgs e)
      {
         var editWindow = new StudentsEdit(null)
         {
            Owner = this
         };
         editWindow.Show();
      }

      private void ListViewItem_PreviewMouseUp(object sender, MouseButtonEventArgs e)
      {
         if (sender is ListViewItem item && item.IsSelected)
         {
            SelectedItem = item.DataContext as Student;
            if (Chooser)
            {
               DialogResult = true;
               Close();
            }
            else
            {
               var editWindow = new StudentsEdit(item.DataContext as Student)
               {
                  Owner = this
               };
               editWindow.Show();
            }
         }
      }

      private void Search_Click(object sender, RoutedEventArgs e)
      {
         LoadList();
      }
   }
}
